Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/SAS_SRC/nemogcm.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/SAS_SRC/nemogcm.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/SAS_SRC/nemogcm.F90	(revision 9019)
@@ -31,6 +31,6 @@
    USE icbini         ! handle bergs, initialisation
    USE icbstp         ! handle bergs, calving, themodynamics and transport
-   USE bdyini         ! open boundary cond. setting       (bdy_init routine). clem: mandatory for LIM3
-   USE bdydta         ! open boundary cond. setting   (bdy_dta_init routine). clem: mandatory for LIM3
+   USE bdyini         ! open boundary cond. setting       (bdy_init routine). mandatory for sea-ice
+   USE bdydta         ! open boundary cond. setting   (bdy_dta_init routine). mandatory for sea-ice
    !
    USE lib_mpp        ! distributed memory computing
@@ -87,7 +87,4 @@
       CALL Agrif_Declare_Var_top   !  "      "   "   "      "  TOP
 # endif
-# if defined key_lim2
-      CALL Agrif_Declare_Var_lim2  !  "      "   "   "      "  LIM
-# endif
 # if defined key_lim3
       CALL Agrif_Declare_Var_lim3  !  "      "   "   "      "  LIM3
@@ -135,11 +132,9 @@
       !
 #if defined key_agrif
-      IF( .NOT. Agrif_Root() ) THEN
          CALL Agrif_ParentGrid_To_ChildGrid()
-         IF( nn_timing == 1 )   CALL timing_finalize
+         IF( ln_timing )   CALL timing_finalize
          CALL Agrif_ChildGrid_To_ParentGrid()
-      ENDIF
-#endif
-      IF( nn_timing == 1 )   CALL timing_finalize
+#endif
+      IF( ln_timing )   CALL timing_finalize
       !
       CALL nemo_closefile
@@ -168,4 +163,6 @@
       INTEGER  ::   ilocal_comm   ! local integer
       INTEGER  ::   ios, inum     !   -      -
+      INTEGER  ::   iiarea, ijarea     ! local integers
+      INTEGER  ::   iirest, ijrest     ! local integers
       CHARACTER(len=120), DIMENSION(30) ::   cltxt, cltxt2, clnam
       CHARACTER(len=80)                 ::   clname
@@ -173,5 +170,5 @@
       NAMELIST/namctl/ ln_ctl   , nn_print, nn_ictls, nn_ictle,   &
          &             nn_isplt , nn_jsplt, nn_jctls, nn_jctle,   &
-         &             nn_timing, nn_diacfl
+         &             ln_timing, ln_diacfl
       NAMELIST/namcfg/ ln_read_cfg, cn_domcfg, ln_write_cfg, cn_domcfg_out, ln_use_jattr
       !!----------------------------------------------------------------------
@@ -221,17 +218,4 @@
       ENDIF
       !
-      jpk = jpkglo
-      !
-#if defined key_agrif
-      IF( .NOT. Agrif_Root() ) THEN       ! AGRIF children: specific setting (cf. agrif_user.F90)
-         jpiglo  = nbcellsx + 2 + 2*nbghostcells
-         jpjglo  = nbcellsy + 2 + 2*nbghostcells
-         jpi     = ( jpiglo-2*jpreci + (jpni-1+0) ) / jpni + 2*jpreci
-         jpj     = ( jpjglo-2*jprecj + (jpnj-1+0) ) / jpnj + 2*jprecj
-         nperio  = 0
-         jperio  = 0
-         ln_use_jattr = .false.
-      ENDIF
-#endif
       !
       !                             !--------------------------------------------!
@@ -290,14 +274,42 @@
 #endif
       ENDIF
+      !
+#if defined key_agrif
+      IF( .NOT. Agrif_Root() ) THEN       ! AGRIF children: specific setting (cf. agrif_user.F90)
+         jpiglo  = nbcellsx + 2 + 2*nbghostcells
+         jpjglo  = nbcellsy + 2 + 2*nbghostcells
+         jpi     = ( jpiglo-2*nn_hls + (jpni-1+0) ) / jpni + 2*nn_hls
+         jpj     = ( jpjglo-2*nn_hls + (jpnj-1+0) ) / jpnj + 2*nn_hls
+         jpimax  = jpi
+         jpjmax  = jpj
+         nperio  = 0
+         jperio  = 0
+         ln_use_jattr = .false.
+      ENDIF
+#endif
 
       IF( Agrif_Root() ) THEN       ! AGRIF mother: specific setting from jpni and jpnj
+         iiarea = 1 + MOD( narea - 1 , jpni )
+         ijarea = 1 + ( narea - 1 ) / jpni
+         iirest = 1 + MOD( jpiglo - 2*nn_hls - 1 , jpni )
+         ijrest = 1 + MOD( jpjglo - 2*nn_hls - 1 , jpnj )
 #if defined key_nemocice_decomp
-         jpi = ( nx_global+2-2*jpreci + (jpni-1) ) / jpni + 2*jpreci    ! first  dim.
-         jpj = ( ny_global+2-2*jprecj + (jpnj-1) ) / jpnj + 2*jprecj    ! second dim. 
+         jpi = ( nx_global+2-2*nn_hls + (jpni-1) ) / jpni + 2*nn_hls    ! first  dim.
+         jpj = ( ny_global+2-2*nn_hls + (jpnj-1) ) / jpnj + 2*nn_hls    ! second dim. 
+         jpimax  = jpi
+         jpjmax  = jpj
+         IF( iiarea == jpni ) jpi = jpiglo - (jpni - 1) * (jpi - 2*nn_hls)
+         IF( ijarea == jpnj ) jpj = jpjglo - (jpnj - 1) * (jpj - 2*nn_hls)
 #else
-         jpi = ( jpiglo     -2*jpreci + (jpni-1) ) / jpni + 2*jpreci    ! first  dim.
-         jpj = ( jpjglo     -2*jprecj + (jpnj-1) ) / jpnj + 2*jprecj    ! second dim.
-#endif
-      ENDIF
+         jpi = ( jpiglo     -2*nn_hls + (jpni-1) ) / jpni + 2*nn_hls    ! first  dim.
+         jpj = ( jpjglo     -2*nn_hls + (jpnj-1) ) / jpnj + 2*nn_hls    ! second dim.
+         jpimax  = jpi
+         jpjmax  = jpj
+         IF( iiarea > iirest ) jpi = jpi - 1
+         IF( ijarea > ijrest ) jpj = jpj - 1
+#endif
+      ENDIF
+
+      jpk = jpkglo                                             ! third dim
 
 #if defined key_agrif
@@ -350,29 +362,27 @@
 
       !                                      ! Domain decomposition
-      IF( jpni*jpnj == jpnij ) THEN   ;   CALL mpp_init      ! standard cutting out
-      ELSE                            ;   CALL mpp_init2     ! eliminate land processors
-      ENDIF
-      !
-      IF( nn_timing == 1 )  CALL timing_init
+      CALL mpp_init
+      !
+      IF( ln_timing    )   CALL timing_init
       !
       !                                     ! General initialization
-                            CALL phy_cst    ! Physical constants
-                            CALL eos_init   ! Equation of state
-                            CALL dom_init   ! Domain
-
-     IF( ln_nnogather )     CALL nemo_northcomms   ! Initialise the northfold neighbour lists (must be done after the masks are defined)
-
-      IF( ln_ctl      )     CALL prt_ctl_init   ! Print control
-                            CALL day_init   ! model calendar (using both namelist and restart infos)
+                           CALL phy_cst    ! Physical constants
+                           CALL eos_init   ! Equation of state
+                           CALL dom_init   ! Domain
+
+     IF( ln_nnogather )    CALL nemo_northcomms   ! Initialise the northfold neighbour lists (must be done after the masks are defined)
+
+      IF( ln_ctl      )    CALL prt_ctl_init   ! Print control
+                           CALL day_init   ! model calendar (using both namelist and restart infos)
       IF( ln_rstart )       CALL rst_read_open
 
-                            CALL sbc_init   ! Forcings : surface module 
-
-      ! ==> clem: open boundaries init. is mandatory for LIM3 because ice BDY is not decoupled from  
+                           CALL sbc_init   ! Forcings : surface module 
+
+      ! ==> clem: open boundaries init. is mandatory for sea-ice because ice BDY is not decoupled from  
       !           the environment of ocean BDY. Therefore bdy is called in both OPA and SAS modules. 
       !           This is not clean and should be changed in the future. 
-                            CALL bdy_init
+                           CALL bdy_init
       ! ==>
-                            CALL icb_init( rdt, nit000)   ! initialise icebergs instance
+                           CALL icb_init( rdt, nit000)   ! initialise icebergs instance
       
       IF(lwp) WRITE(numout,*) 'Euler time step switch is ', neuler
@@ -403,5 +413,6 @@
          WRITE(numout,*) '      number of proc. following i     nn_isplt   = ', nn_isplt
          WRITE(numout,*) '      number of proc. following j     nn_jsplt   = ', nn_jsplt
-         WRITE(numout,*) '      timing activated    (0/1)       nn_timing  = ', nn_timing
+         WRITE(numout,*) '      timing by routine               ln_timing  = ', ln_timing
+         WRITE(numout,*) '      CFL diagnostics                 ln_diacfl  = ', ln_diacfl
       ENDIF
       !
@@ -413,4 +424,9 @@
       isplt     = nn_isplt
       jsplt     = nn_jsplt
+!!gm to be remove at the end of the 2017 merge party
+      if( ln_timing ) then  ;  nn_timing = 1
+      else                  ;  nn_timing = 0
+      endif
+!!gm end
 
       IF(lwp) THEN                  ! control print
@@ -508,5 +524,5 @@
       USE dom_oce   , ONLY: dom_oce_alloc
       USE bdy_oce   , ONLY: ln_bdy, bdy_oce_alloc
-      USE oce         ! clem: mandatory for LIM3 because needed for bdy arrays
+      USE oce       ! mandatory for sea-ice because needed for bdy arrays
       !
       INTEGER :: ierr
@@ -515,5 +531,5 @@
       ierr =        dia_wri_alloc   ()
       ierr = ierr + dom_oce_alloc   ()          ! ocean domain
-      ierr = ierr + oce_alloc       ()          ! (tsn...) needed for agrif and/or lim3 and bdy
+      ierr = ierr + oce_alloc       ()          ! (tsn...) needed for agrif and/or ESIM and bdy
       ierr = ierr + bdy_oce_alloc   ()          ! bdy masks (incl. initialization)
       !
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/SAS_SRC/sbcssm.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/SAS_SRC/sbcssm.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/SAS_SRC/sbcssm.F90	(revision 9019)
@@ -114,6 +114,6 @@
          ENDIF
       ELSE
-         sst_m(:,:) = 0._wp
-         sss_m(:,:) = 0._wp
+         sss_m(:,:) = 35._wp                             ! =35. to obtain a physical value for the freezing point
+         CALL eos_fzp( sss_m(:,:), sst_m(:,:) )          ! sst_m is set at the freezing point
          ssu_m(:,:) = 0._wp
          ssv_m(:,:) = 0._wp
@@ -313,5 +313,5 @@
    ENDIF
  
-      CALL sbc_ssm( nit000 )   ! need to define ss?_m arrays used in limistate
+      CALL sbc_ssm( nit000 )   ! need to define ss?_m arrays used in iceistate
       l_initdone = .TRUE.
       !
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/SAS_SRC/step.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/SAS_SRC/step.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/SAS_SRC/step.F90	(revision 9019)
@@ -24,5 +24,5 @@
    USE diawri           ! Standard run outputs             (dia_wri routine)
    USE bdy_oce   , ONLY: ln_bdy
-   USE bdydta           ! clem: mandatory for LIM3
+   USE bdydta           ! mandatory for sea-ice
    USE stpctl           ! time stepping control            (stp_ctl routine)
    !
@@ -37,5 +37,5 @@
 
 #if defined key_agrif
-   USE agrif_oce, ONLY: lk_agrif_debug  !clem
+   USE agrif_oce, ONLY: lk_agrif_debug
 #endif
    
@@ -89,5 +89,5 @@
                              CALL iom_setkt( kstp - nit000 + 1, cxios_context )   ! tell iom we are at time step kstp
 
-      ! ==> clem: open boundaries is mandatory for LIM3 because ice BDY is not decoupled from  
+      ! ==> clem: open boundaries is mandatory for sea-ice because ice BDY is not decoupled from  
       !           the environment of ocean BDY. Therefore bdy is called in both OPA and SAS modules.
       !           From SAS: ocean bdy data are wrong  (but we do not care) and ice bdy data are OK.  
@@ -114,5 +114,5 @@
                              CALL dia_wri_state( 'output.abort', kstp )
       ENDIF
-      IF( kstp == nit000   ) CALL iom_close( numror )     ! close input  ocean restart file (clem: not sure...)
+      IF( kstp == nit000   ) CALL iom_close( numror )     ! close input  ocean restart file
       
       !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
@@ -127,5 +127,5 @@
 #endif
       !
-      IF( nn_timing == 1 .AND.  kstp == nit000  )   CALL timing_reset
+      IF( ln_timing .AND.  kstp == nit000  )   CALL timing_reset
       !
    END SUBROUTINE stp
